#ifndef LINUX
    #include "bass.h"
#endif

int current_track = -1;
int tracks_num = 6;
char *tracks[] = 
{
    "data/m00.mo3",
    "data/m01.mo3",
    "data/m02.mo3",
    "data/m03.mo3",
    "data/m04.mo3",
    "data/m05.mo3",
};
#ifndef LINUX
DWORD chan = 0;
#endif

void music_init()
{
#ifndef LINUX
    BASS_Init( -1, 44100, 0, 0, NULL );
#endif
}

void music_close()
{
#ifndef LINUX
    BASS_Free();
#endif
}

void music_play( char *filename )
{
#ifndef LINUX
    if( chan )
    {
	BASS_ChannelStop( chan );
    }
    chan = BASS_MusicLoad( FALSE, filename, 0, 0, BASS_MUSIC_AUTOFREE | BASS_MUSIC_RAMPS, 0 );
    BASS_ChannelPlay( chan, FALSE );
#endif
}

void music_control()
{
#ifndef LINUX
    if( chan == 0 || !BASS_ChannelIsActive( chan ) )
    {
	//Go to the next track:
	current_track++;
	if( current_track >= tracks_num ) current_track = 0;
	music_play( tracks[ current_track ] );
    }
#endif
}

void change_track( int track_num )
{
#ifndef LINUX
    if( track_num == 255 )
    {
	BASS_ChannelPause( chan );
	return;
    }
    if( track_num != current_track )
    if( track_num <= tracks_num - 1 && track_num >= 0 )
    {
	current_track = track_num - 1;
	BASS_ChannelSlideAttributes(chan,-1,-2,-101,200);
	while (BASS_ChannelIsSliding(chan)) Sleep(1);
    }
#endif
}

void render_piece_of_sound( signed short *buffer, int buffer_size, void *user_data )
{
}
