#ifndef __CORE__
#define __CORE__

#define PROG_VERSION "SunDog Engine"
#define PROG_DATE    __DATE__

//#define COLOR8BITS	//8 bit color
//#define COLOR16BITS	//16 bit color
//#define COLOR32BITS	//32 bit color
//#define GRAYSCALE	//Used with COLOR8BITS for grayscale palette
//#define LINUX		//OS = Linux
//#define WIN		//OS = Windows
//#define PALMOS	//OS = PalmOS
//#define X11		//X11 support
//#define DIRECTX	//DirectDraw support
//#define OPENGL	//OpenGL support
//#define GDI		//GDI support
//#define FRAMEBUFFER	//Use framebuffer
//#define DEBUGMODE	//No debug messages
//#define SLOWMODE	//For some slow devices
//#define NATIVEARM	//PalmOS native ARM code
//#define NOSTORAGE	//Do not use the Storage Heap and MemSemaphores
//#define PALMLOWRES	//PalmOS low-density screen

//Variations:
//WIN32:  COLOR32BITS + WIN [ + OPENGL / GDI ]
//LINUX:  COLOR32BITS + LINUX [ + OPENGL / X11 ]
//PALMOS: COLOR8BITS + PALMOS [ + NOSTORAGE / PALMLOWRES / SLOWMODE ]

typedef unsigned char   uchar;
typedef unsigned short  uint16;
typedef short           int16;
typedef unsigned long   ulong;
typedef signed long     slong;

#ifdef OPENGL
    #define FRAMEBUFFER
#endif

#ifdef DIRECTX
    #define FRAMEBUFFER
#endif

#ifdef PALMOS
    //Code sections: (for PalmOS GCC only!!)
    #define sec1 __attribute__ ((section ("sec1")))  /*Main code*/
    #define sec2 __attribute__ ((section ("sec2")))  /*Main code part 2*/
    #define sec3 __attribute__ ((section ("sec3")))  /*Sound engine*/
    #define sec4 __attribute__ ((section ("sec4")))  /*Window manager*/
    #define NATIVEARM
#else
    #define sec1  /*nothing*/
    #define sec2  /*nothing*/
    #define sec3  /*nothing*/
    #define sec4  /*nothing*/
    #define NONPALM
#endif

#endif

