#ifndef __SOUND__
#define __SOUND__

#ifndef NOSOUND

//Main sound header

#include "core/core.h"

//Structures:

enum 
{
    STATUS_STOP = 0,
    STATUS_PLAY,
};

struct sound_struct
{
    long	status;		    //Current playing status
    long	need_to_stop;	    //Set it to 1 if you want to stop sound stream
    long	stream_stoped;	    //If stream really stoped

    void	*user_data;	    //Data for user defined render_piece_of_sound()

    int		freq;
    int		channels;
};

//Variables:

extern void *user_sound_data;

#ifdef LINUX
extern int dsp;
#endif

//Functions:

int main_callback( void*, long, void*, long );
extern void render_piece_of_sound( signed short *buffer, int buffer_size, void *user_data );

void sound_stream_init( int freq, int channels );
void sound_stream_play(void);
void sound_stream_stop(void);
void sound_stream_close(void);

#endif

#endif
