#ifndef __UTILS_H__
#define __UTILS_H__

//LIST:

#define MAX_SIZE 16000
#define MAX_ITEMS (long)4000

struct list_data
{
    char *items;     //Items data
    long *items_ptr; //Item pointers
    long items_num;  //Number of items; 
    long selected_item;
    long start_item;
};

void list_init( list_data *data );
void list_close( list_data *data );
void list_clear( list_data *data );
void list_reset_selection( list_data *data );
void list_add_item( char *item, char attr, list_data *data );
void list_delete_item( long item_num, list_data *data );
void list_move_item_up( long item_num, list_data *data );
void list_move_item_down( long item_num, list_data *data );
char* list_get_item( long item_num, list_data *data );
char list_get_attr( long item_num, list_data *data );
long list_get_selected_num( list_data *data );
void list_set_selected_num( long sel, list_data *data );
long list_compare_items( long item1, long item2, list_data *data );
void list_sort( list_data *data );

//RANDOM GENERATOR:

void set_seed( unsigned long seed );
unsigned long pseudo_random( void );

//STRINGS:

void int_to_string( int value, char *str );
int string_to_int( char *str );
int hex_string_to_int( char *str );

#endif
